/*
  EventManager.hpp
  Copyright (C) 2013  Giménez, Christian N.
  
  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
  
  viernes 11 de enero del 2013     */


#ifndef __EVENTMANAGER_HPP
#define __EVENTMANAGER_HPP 1

// using namespace std;

#include <OgreCamera.h>
#include <OgreEntity.h>
#include <OgreLogManager.h>
#include <OgreRoot.h>
#include <OgreViewport.h>
#include <OgreSceneManager.h>
#include <OgreRenderWindow.h>
#include <OgreConfigFile.h>

#include <OISEvents.h>
#include <OISInputManager.h>
#include <OISKeyboard.h>
#include <OISMouse.h>

#include <SdkTrays.h>
#include <SdkCameraMan.h>

#include "MyKeyListener.hpp"
#include "TinyOgre.h"

class TinyOgre;
class MyKeyListener;

/**
   I'm a EventManager class, I'm a FrameListener.

   Intentaremos utilizar esta clase para manipular el teclado y mover algunos objetos.
 */
class EventManager : public Ogre::FrameListener {
  
protected:
  TinyOgre* tiny;
  OIS::Keyboard* keyboard;
  OIS::Mouse* mouse;
  OIS::InputManager* input_manager;
  MyKeyListener* key_listener;
  
public:
  EventManager(TinyOgre* tiny, Ogre::RenderWindow* mwin);
  ~EventManager();

  /**
     Me registro dentro de Ogre::Root
   */
  void registrar();

  /**
     Redefinimos el más eficiente de los frame listeners.
   */
  virtual bool frameRenderingQueued(const Ogre::FrameEvent& evt);

  virtual bool frameEnded(const Ogre::FrameEvent& evt);

  virtual bool frameStarted(const Ogre::FrameEvent& evt);
};


#endif /* __EVENTMANAGER_HPP */

