
    // Message.hpp
    // Copyright (C) 2013  Giménez, Christian N.

    // This program is free software: you can redistribute it and/or modify
    // it under the terms of the GNU General Public License as published by
    // the Free Software Foundation, either version 3 of the License, or
    // (at your option) any later version.

    // This program is distributed in the hope that it will be useful,
    // but WITHOUT ANY WARRANTY; without even the implied warranty of
    // MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    // GNU General Public License for more details.

    // You should have received a copy of the GNU General Public License
    // along with this program.  If not, see <http://www.gnu.org/licenses/>.

    // Miércoles 23 De Enero Del 2013    


#ifndef __MESSAGE_HPP__
#define __MESSAGE_HPP__

#include <string>
#include <iostream>

using namespace std;

namespace Terminal{

  /**
     I show preforamated messages to the terminal!
     
     Use @code #include "Terminal.hpp" @endcode for writing messages and errors output to the terminal.
     
  */
  class Message{
    
  public:
    /**
       Display a message in the error terminal.
       
       @param c A string with the class name.
       @param str A string with the text to display.
    */
    static void show(string c, string str);
    static void show(string c, int str);
    static void show(string c, float str);
    static void show(string c, double str);
  };
  
}
#endif
